/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package logika;

import domen.Festival;
import domen.Film;
import domen.Grad;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import komunikacija.Komunikacija;
import transfer.TransferObjekatOdgovor;
import transfer.TransferObjekatZahtev;
import util.Konstante;

/**
 *
 * @author student1
 */
public class Kontroler {

    public static List<Grad> vratiGradove() {
        TransferObjekatZahtev toz = new TransferObjekatZahtev();
        toz.setOperacija(Konstante.VRATI_MESTA);
        List<Grad> lg = new ArrayList<>();
        try {
            Komunikacija.vratiObjekat().posalji(toz);
            TransferObjekatOdgovor odgovor = Komunikacija.vratiObjekat().procitaj();
            lg = (List<Grad>) odgovor.getOdgovor();
        } catch (IOException ex) {
            Logger.getLogger(Kontroler.class.getName()).log(Level.SEVERE, null, ex);
        } catch (ClassNotFoundException ex) {
            Logger.getLogger(Kontroler.class.getName()).log(Level.SEVERE, null, ex);
        }
        return lg;
    }

    public static List<Film> vratiFilmove() {
        TransferObjekatZahtev toz = new TransferObjekatZahtev();
        toz.setOperacija(Konstante.VRATI_FILMOVE);
        List<Film> lg = new ArrayList<>();
        try {
            Komunikacija.vratiObjekat().posalji(toz);
            TransferObjekatOdgovor odgovor = Komunikacija.vratiObjekat().procitaj();
            lg = (List<Film>) odgovor.getOdgovor();
        } catch (IOException ex) {
            Logger.getLogger(Kontroler.class.getName()).log(Level.SEVERE, null, ex);
        } catch (ClassNotFoundException ex) {
            Logger.getLogger(Kontroler.class.getName()).log(Level.SEVERE, null, ex);
        }
        return lg;
    }

    public static int vratiID() {
        TransferObjekatZahtev toz = new TransferObjekatZahtev();
        toz.setOperacija(Konstante.KREIRAJ_SIFRU);
        int id = 0;
        try {
            Komunikacija.vratiObjekat().posalji(toz);
            TransferObjekatOdgovor odgovor = Komunikacija.vratiObjekat().procitaj();
            id = (int) odgovor.getOdgovor();
        } catch (IOException ex) {
            Logger.getLogger(Kontroler.class.getName()).log(Level.SEVERE, null, ex);
        } catch (ClassNotFoundException ex) {
            Logger.getLogger(Kontroler.class.getName()).log(Level.SEVERE, null, ex);
        }
        return id;
    }

    public static void sacuvajFestival(Festival f) {
        TransferObjekatZahtev toz = new TransferObjekatZahtev();
        toz.setOperacija(Konstante.SACUVAJ_FESTIVAL);
        toz.setParametar(f);
        try {
            Komunikacija.vratiObjekat().posalji(toz);
            TransferObjekatOdgovor odgovor = Komunikacija.vratiObjekat().procitaj();
            
        } catch (IOException ex) {
            Logger.getLogger(Kontroler.class.getName()).log(Level.SEVERE, null, ex);
        } catch (ClassNotFoundException ex) {
            Logger.getLogger(Kontroler.class.getName()).log(Level.SEVERE, null, ex);
        }
       
    }

}
