/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package dbb;

import domen.Festival;
import domen.Film;
import domen.Grad;
import domen.Projekcija;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.sql.Timestamp;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 *
 * @author student1
 */
public class DBBroker {

    private Connection connection;

    public void ucitajDriver() throws RuntimeException {
        try {
            Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
//            driver je klasa
        } catch (Exception e) {
            throw new RuntimeException("Neuspesno ucitavanje drivera!");
        }
    }

    public void otvoriKonekciju() throws RuntimeException {
        try {
            connection = DriverManager.getConnection("jdbc:odbc:bazaJovana", "", "");
//            jdbc:protokol:naziv_baze
            connection.setAutoCommit(false); //zahteva eksplicitnu potvrdu transakcije
        } catch (Exception e) {
            throw new RuntimeException("Neuspesno otvaranje konekcije!");
        }
    }

    public void commitTransakcije() throws RuntimeException {
        try {
            connection.commit();
        } catch (SQLException ex) {
            throw new RuntimeException("Neuspesan commit transakcije!");
        }
    }

    public void rollbackTransakcije() throws RuntimeException {
        try {
            connection.rollback();
        } catch (SQLException ex) {
            throw new RuntimeException("Neuspesan rollback transakcije!");
        }
    }

    public void zatvoriKonekciju() throws RuntimeException {
        try {
            connection.close();
        } catch (Exception e) {
            throw new RuntimeException("Neuspesno zatvaranje konekcije!");
        }
    }

    public List<Grad> vratiGradove() throws RuntimeException {
        List<Grad> lg = new ArrayList<>();
        try {
            String upit = "SELECT * FROM Grad";
            Statement st = connection.createStatement();
            ResultSet rs = st.executeQuery(upit);
            while (rs.next()) {
                Grad g = new Grad();
                int id = rs.getInt("GradID");
                long ptt = rs.getLong("Ptt");
                String naziv = rs.getString("Naziv");
                g.setGradID(id);
                g.setPtt(ptt);
                g.setNaziv(naziv);

                lg.add(g);
            }
        } catch (SQLException ex) {
            throw new RuntimeException("Nemoguce vratiti mesta!");
        }

        return lg;
    }

    public List<Film> vratiFilmove() throws RuntimeException {
        List<Film> lg = new ArrayList<>();
        try {
            String upit = "SELECT * FROM Film";
            Statement st = connection.createStatement();
            ResultSet rs = st.executeQuery(upit);
            while (rs.next()) {
                Film f = new Film();
                f.setFilmID(rs.getInt("FilmID"));
                f.setNaziv(rs.getString("Naziv"));
                f.setReziser(rs.getString("Reziser"));
                f.setGodina(rs.getInt("Godina"));

                lg.add(f);
            }
        } catch (SQLException ex) {
            throw new RuntimeException("Nemoguce vratiti mesta!");
        }

        return lg;
    }

    public int vratiFestivalID() throws SQLException {
        String sql = "Select MAX(FestivalID) from Festival";
        Statement s = connection.createStatement();
        ResultSet rs = s.executeQuery(sql);
        rs.next();
        int id = rs.getInt(1) + 1;
        return id;
    }

    public void sacuvajFestival(Festival f) throws SQLException {
        String sql = "Insert into Festival values (?,?,?,?,?)";
        PreparedStatement ps = connection.prepareStatement(sql);

        ps.setInt(1, f.getFestivalID());
        ps.setString(2, f.getNaziv());
        ps.setDate(3, new java.sql.Date(f.getDatumOD().getTime()));
        ps.setDate(4, new java.sql.Date(f.getDatumDO().getTime()));
        ps.setInt(5, f.getGrad().getGradID());

        ps.executeUpdate();

        int projekcijaID = vratiIDProjekcije(f.getFestivalID());

        List<Projekcija> lp = f.getProjekcije();

        for (Projekcija projekcija : lp) {
            sql = "Insert into Projekcija values (?,?,?,?)";
            ps = connection.prepareStatement(sql);
            ps.setInt(1, f.getFestivalID());
            ps.setInt(2, projekcijaID++);
            ps.setTimestamp(3, (Timestamp) projekcija.getDatumVremeProjekcije());
            ps.setInt(4, projekcija.getFilm().getFilmID());

            ps.executeUpdate();
        }
        ps.close();
    }

    private int vratiIDProjekcije(int idF) throws SQLException {
        String sql = "Select MAX(ProjekcijaID) from Projekcija where FestivalID=" + idF;
        Statement s = connection.createStatement();
        ResultSet rs = s.executeQuery(sql);
        rs.next();
        int id = rs.getInt(1) + 1;
        return id;
    }

}
