/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package niti;

import domen.Festival;
import domen.Film;
import domen.Grad;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.net.Socket;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import logika.Kontroler;
import transfer.TransferObjekatOdgovor;
import transfer.TransferObjekatZahtev;
import util.Konstante;

/**
 *
 * @author student1
 */
public class NitKlijent extends Thread {

    private Socket socket;
    private boolean kraj = false;

    public NitKlijent(Socket socket) {
        this.socket = socket;
    }

    @Override
    public void run() {
        try {
            izvrsenjeOperacije();
        } catch (ClassNotFoundException ex) {
            Logger.getLogger(NitKlijent.class.getName()).log(Level.SEVERE, null, ex);
        } catch (IOException ex) {
            Logger.getLogger(NitKlijent.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    private void izvrsenjeOperacije() throws ClassNotFoundException, IOException {
        while (!kraj) {
            ObjectInputStream in = null;
            ObjectOutputStream out = null;
            TransferObjekatOdgovor odgovor = null;
            try {
                in = new ObjectInputStream(socket.getInputStream());
                odgovor = new TransferObjekatOdgovor();
                TransferObjekatZahtev toz = (TransferObjekatZahtev) in.readObject();
                switch (toz.getOperacija()) {
                    case Konstante.VRATI_MESTA:
                        System.out.println("O: " + Konstante.VRATI_MESTA);
                        List<Grad> lg = Kontroler.vratiObjekat().vratiGradove();
                        odgovor.setOdgovor(lg);
                        break;
                    case Konstante.VRATI_FILMOVE:
                        System.out.println("O: " + Konstante.VRATI_FILMOVE);
                        List<Film> lf = Kontroler.vratiObjekat().vratiFilmove();
                        odgovor.setOdgovor(lf);
                        break;
                    case Konstante.KREIRAJ_SIFRU:
                        System.out.println("O: " + Konstante.KREIRAJ_SIFRU);
                        int id = Kontroler.vratiObjekat().vratiIDFestivala();
                        odgovor.setOdgovor(id);
                        break;
                    case Konstante.SACUVAJ_FESTIVAL:
                        System.out.println("O: " + Konstante.SACUVAJ_FESTIVAL);
                        Festival f = (Festival) toz.getParametar();
                        Kontroler.vratiObjekat().sacuvajFestival(f);
                        
                        break;

                }

            } catch (Exception ex) {
                //Logger.getLogger(NitKlijent.class.getName()).log(Level.SEVERE, null, ex);
                odgovor.setIzuzetak(ex);
                odgovor.setRezultat(ex.getMessage());
            }
            posaljiOdgovor(odgovor);
        }
    }

    private void posaljiOdgovor(TransferObjekatOdgovor odgovor) throws IOException {
        ObjectOutputStream outSocket = new ObjectOutputStream(socket.getOutputStream());
        outSocket.writeObject(odgovor);
    }

}
